#include <stdio.h>
#include <math.h>
#include <GL/glut.H>

//a
float max(float f1, float f2){
  if(f1 > f2)
    return f1;
  else
    return f2;
}

//
float min(float f1, float f2){
  if(f1 < f2)
    return f1;
  else
    return f2;
}

//^{[
float metaball(float x, float y, float z, float a, float b, float c, float r){
  float d2 = (x-a)*(x-a) + (y-b)*(y-b) + (z-c)*(z-c);
  return exp(-d2/(2*r*r));
}

//̊֐ (ۑ2-1  2-2)
float myFunction(float x, float y, float z){
  //
  float s = 0.6 - sqrt(x*x + y*y + z*z);
  
  //g[X z 
  float d = sqrt(x*x + y*y);
  float t1 = 0.15 - sqrt( (d-0.6)*(d-0.6) + z*z );
  
  //g[X x 
  d = sqrt(y*y + z*z);
  float t2 = 0.3 - sqrt( (d-0.6)*(d-0.6) + x*x );
  
  //ačvZ
  return min(max(s, t1), -t2);
}

/************ ͉̉ۑɂ͊֌ŴȂ֐ (݂ȂĂ悢) *****************/

//iqŃTvꂽA֐ (Tv̈ [-1,1]^3)
#define N 200
float F[N][N][N];

void sampleFunction(){
  for(int i=0; i<N; i++){
    float z = 2.0*i/(N-1) - 1.0;
    for(int j=0; j<N; j++){
      float y = 2.0*j/(N-1) - 1.0;
      for(int k=0; k<N; k++){
        float x = 2.0*k/(N-1) - 1.0;
        F[i][j][k] = myFunction(x,y,z);
      }
    }
  }
}

int vN;
float (*ver)[3];
int qN;
int (*quad)[4];
int grid[N-1][N-1][N-1];
float iso;

void polygonize(){
  if(ver != NULL){
    delete[] ver;
    delete[] quad;
  }
  
  for(int i=0; i<N-1; i++)
  for(int j=0; j<N-1; j++)
  for(int k=0; k<N-1; k++)
    grid[i][j][k] = -1;
  
  vN = 0;
  for(int i=0; i<N-1; i++)
  for(int j=0; j<N-1; j++)
  for(int k=0; k<N-1; k++){
    float v[8] = {F[i][j][k]-iso, F[i][j][k+1]-iso, F[i][j+1][k]-iso, F[i][j+1][k+1]-iso,
      F[i+1][j][k]-iso, F[i+1][j][k+1]-iso, F[i+1][j+1][k]-iso, F[i+1][j+1][k+1]-iso};
    for(int l=1; l<8; l++)
      if(v[0]*v[l] <= 0){
        grid[i][j][k] = vN++;
        break;
      }
    if(v[0]*v[1] <= 0)
      qN++;
    if(v[0]*v[2] <= 0)
      qN++;
    if(v[0]*v[4] <= 0)
      qN++;
  }
  
  ver = new float[vN][3];
  vN = 0;
  quad = new int[qN][4];
  qN = 0;
  
  static int edge[12][2] = {
    {0,1},{2,3},{4,5},{6,7}, {0,2},{4,6},{5,7},{1,3}, {0,4},{1,5},{2,6},{3,7}
  };
  
  for(int i=0; i<N-1; i++)
  for(int j=0; j<N-1; j++)
  for(int k=0; k<N-1; k++){
    if(grid[i][j][k] < 0)
      continue;
    
    float v[8] = {
      F[i][j][k]-iso, F[i][j][k+1]-iso, F[i][j+1][k]-iso, F[i][j+1][k+1]-iso,
      F[i+1][j][k]-iso, F[i+1][j][k+1]-iso, F[i+1][j+1][k]-iso, F[i+1][j+1][k+1]-iso
      };
    
    float cp[8][3] = {
      {2.0*k/(N-1) - 1.0,     2.0*j/(N-1) - 1.0,     2.0*i/(N-1) - 1.0},
      {2.0*(k+1)/(N-1) - 1.0, 2.0*j/(N-1) - 1.0,     2.0*i/(N-1) - 1.0},
      {2.0*k/(N-1) - 1.0,     2.0*(j+1)/(N-1) - 1.0, 2.0*i/(N-1) - 1.0},
      {2.0*(k+1)/(N-1) - 1.0, 2.0*(j+1)/(N-1) - 1.0, 2.0*i/(N-1) - 1.0},
      {2.0*k/(N-1) - 1.0,     2.0*j/(N-1) - 1.0,     2.0*(i+1)/(N-1) - 1.0},
      {2.0*(k+1)/(N-1) - 1.0, 2.0*j/(N-1) - 1.0,     2.0*(i+1)/(N-1) - 1.0},
      {2.0*k/(N-1) - 1.0,     2.0*(j+1)/(N-1) - 1.0, 2.0*(i+1)/(N-1) - 1.0},
      {2.0*(k+1)/(N-1) - 1.0, 2.0*(j+1)/(N-1) - 1.0, 2.0*(i+1)/(N-1) - 1.0}
    };
    
    float p[12][3];
    int pN = 0;
    ver[vN][0] = ver[vN][1] = ver[vN][2] = 0;
    for(int l=0; l<12; l++){
      int c1 = edge[l][0];
      int c2 = edge[l][1];
      if(v[c1]*v[c2] <= 0){
        float w1 = fabs(v[c2])/(fabs(v[c1])+fabs(v[c2]));
        float w2 = fabs(v[c1])/(fabs(v[c1])+fabs(v[c2]));
        ver[vN][0] += p[pN][0] = w1*cp[c1][0] + w2*cp[c2][0];
        ver[vN][1] += p[pN][1] = w1*cp[c1][1] + w2*cp[c2][1];
        ver[vN][2] += p[pN][2] = w1*cp[c1][2] + w2*cp[c2][2];
        pN++;
      }
    }
    ver[vN][0] /= pN;
    ver[vN][1] /= pN;
    ver[vN][2] /= pN;
    vN++;
    
    if(v[0]*v[1] <= 0 && i > 0 && j > 0){
      if(v[0] > 0){
        quad[qN][0] = grid[i][j][k];
        quad[qN][1] = grid[i][j-1][k];
        quad[qN][2] = grid[i-1][j-1][k];
        quad[qN][3] = grid[i-1][j][k];
      }
      else{
        quad[qN][0] = grid[i][j][k];
        quad[qN][3] = grid[i][j-1][k];
        quad[qN][2] = grid[i-1][j-1][k];
        quad[qN][1] = grid[i-1][j][k];
      }
      qN++;
    }
    if(v[0]*v[2] <= 0 && k > 0 && i > 0){
      if(v[0] > 0){
        quad[qN][0] = grid[i][j][k];
        quad[qN][1] = grid[i-1][j][k];
        quad[qN][2] = grid[i-1][j][k-1];
        quad[qN][3] = grid[i][j][k-1];
      }
      else{
        quad[qN][0] = grid[i][j][k];
        quad[qN][3] = grid[i-1][j][k];
        quad[qN][2] = grid[i-1][j][k-1];
        quad[qN][1] = grid[i][j][k-1];
      }
      qN++;
    }
    if(v[0]*v[4] <= 0 && j > 0 && k > 0){
      if(v[0] > 0){
        quad[qN][0] = grid[i][j][k];
        quad[qN][1] = grid[i][j][k-1];
        quad[qN][2] = grid[i][j-1][k-1];
        quad[qN][3] = grid[i][j-1][k];
      }
      else{
        quad[qN][0] = grid[i][j][k];
        quad[qN][3] = grid[i][j][k-1];
        quad[qN][2] = grid[i][j-1][k-1];
        quad[qN][1] = grid[i][j-1][k];
      }
      qN++;
    }
  }
}

//]̂߂̕ϐ
int mouseX, mouseY;
float qw, qx, qy, qz;
float zoom;
float shiftX, shiftY;
int width, height;

//lӌ`̖@̌vZ֐ 
void newell(float n[3], float **v, int vN){
  n[0] = n[1] = n[2] = 0;
  for(int i=0; i<vN; i++){
    float* p = v[i];
    float* q = v[(i+1)%vN];
    n[0] += (p[1]-q[1])*(p[2]+q[2]);
    n[1] += (p[2]-q[2])*(p[0]+q[0]);
    n[2] += (p[0]-q[0])*(p[1]+q[1]);
  }
  float l = (float)sqrt(n[0]*n[0]+n[1]*n[1]+n[2]*n[2]);
  if(l != 0){
    n[0] /= l;
    n[1] /= l;
    n[2] /= l;
  }
}

//lʂ\
void drawIso(){
  glPolygonMode(GL_FRONT, GL_FILL);
  glShadeModel(GL_FLAT);
  glEnable(GL_LIGHTING);
  
  for(int i=0; i<qN; i++){
    int* q = quad[i];
    float *v[4] = {ver[q[0]], ver[q[1]], ver[q[2]], ver[q[3]]};
    float n[3];
    newell(n, v, 4);
    glBegin(GL_POLYGON);
      glNormal3fv(n);
      glVertex3fv(v[0]);
      glVertex3fv(v[1]);
      glVertex3fv(v[2]);
      glVertex3fv(v[3]);
    glEnd();
  }
}

void display(void){
  //XN[ƕϊs
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
  glLoadIdentity();
  
  //]Ȃǂ̕ϊ
  glTranslatef(shiftX, shiftY, 0);
  float s = (float)sqrt(qx*qx + qy*qy + qz*qz);
  if(s != 0)
    glRotatef(2.0f*(float)acos(qw)*180/3.1412f, qx/s, qy/s,qz/s);
  
  drawIso();
  
  //XN[XV
  glFlush(); 
  glutSwapBuffers(); 
} 


void myinit(){
  GLfloat ambient[4] = {0.3f,0.3f,0.3f,1.0f};
  
  GLfloat material_color[4] = {1,1,1,1.0f};
  GLfloat material_specular[4] = {0.5f,0.5f,0.5f,1.0f};
  GLfloat material_ambient[4] = {0.1,0.1,0.0,1.0};
  
  GLfloat light_position1[4] = {-52, -16, -50, 0};
  GLfloat light_position2[4] = {-26, -48, -50, 0};
  GLfloat light_position3[4] = { 16, -52, -50, 0};
  
  GLfloat direction1[3] = {52,16,50};
  GLfloat direction2[3] = {26,48,50};
  GLfloat direction3[3] = {-16,52,50};
  
  GLfloat color1[4], color2[4], color3[4];
  
  color1[0] = 1.0; color1[1] = 0.0; color1[2] = 0.0; color1[3] = 1;
  color2[0] = 0.0; color2[1] = 1.0; color2[2] = 0.0; color2[3] = 1;
  color3[0] = 0.0; color3[1] = 0.0; color3[2] = 1.0; color3[3] = 1;
  
  glLightfv(GL_LIGHT0, GL_POSITION, light_position1);
  glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, direction1);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, color1);
  glLightfv(GL_LIGHT0, GL_SPECULAR, color1);
  
  glLightfv(GL_LIGHT1, GL_POSITION, light_position2);
  glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, direction2);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, color2);
  glLightfv(GL_LIGHT1, GL_SPECULAR, color2);
  
  glLightfv(GL_LIGHT2, GL_POSITION, light_position3);
  glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction3);
  glLightfv(GL_LIGHT2, GL_DIFFUSE, color3);
  glLightfv(GL_LIGHT2, GL_SPECULAR, color3);
  
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);
  
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_color);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_ambient);
  glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 128);
  
  glShadeModel(GL_SMOOTH);   /* smooth shading */
  glEnable(GL_LIGHTING); /* enable lighting */
  glEnable(GL_LIGHT0);   /* enable light 0 */
  glEnable(GL_LIGHT1);
  glEnable(GL_LIGHT2);
  glEnable(GL_DEPTH_TEST); /* enable z buffer */
  glDepthFunc(GL_LEQUAL);
  
  glEnable(GL_LINE_SMOOTH);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);

  
  glClearColor (1.0, 1.0, 1.0, 1.0);
}

void myReshape(int w, int h){
  width = w;
  height = h;
  
  glViewport(0, 0, w, h); 
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity(); 
  if (w <= h) 
    glOrtho(-1.0/zoom, 1.0/zoom,
            -1.0*h/w/zoom, 1.0*h/w/zoom,
            -100.0, 100.0); 
  else 
    glOrtho(-1.0*w/h/zoom, 1.0*w/h/zoom,
            -1.0/zoom, 1.0/zoom,
            -100.0, 100.0);
  gluLookAt(0,0,-10, 0,0,0, 0,-1,0);
  glMatrixMode(GL_MODELVIEW); 
} 

void mouse(int btn, int state, int x, int y){ 
  /* mouse callback, selects an axis about which to rotate */
  if(state == GLUT_DOWN){
    mouseX = x;
    mouseY = y;
  }
  else if(btn==GLUT_LEFT_BUTTON){
    float mx = -0.0025f*(x - mouseX)/zoom;
    float my = 0.0025f*(y - mouseY)/zoom;
    
    //rotation
    float c = (float)cos(my);
    float s = (float)sin(my);
    
    float rw = c*qw - s*qx;
    float rx = c*qx + s*qw;
    float ry = c*qy - s*qz;
    float rz = c*qz + s*qy;
    
    c = (float)cos(mx);
    s = (float)sin(mx);
    
    qw = c*rw - s*ry;
    qx = c*rx + s*rz;
    qy = c*ry + s*rw;
    qz = c*rz - s*rx;
    
    float n = (float)sqrt(qw*qw + qx*qx + qy*qy + qz*qz);
    if(n != 0){
      qw /= n;
      qx /= n;
      qy /= n;
      qz /= n;
    }
    else{
      qw = 1.0f;
      qx = qy = qz = 0.0f;
    }
    display();
  }
  else if(btn==GLUT_RIGHT_BUTTON){
    zoom -= 0.0025f*(y - mouseY);
    if(zoom > 20.0f) zoom = 20.0f;
    else if(zoom < 0.05f) zoom = 0.05f;
    myReshape(width, height);
    display();
  }
  else if(btn==GLUT_MIDDLE_BUTTON){
    shiftX += 0.0025f*(x - mouseX)/zoom;
    shiftY += 0.0025f*(y - mouseY)/zoom;
    display();
  }
} 

void specialKeys(int key, int x, int y){
  switch (key) {
  case GLUT_KEY_DOWN:
    iso -= 0.02;
    printf("l %f\n", iso);
    polygonize();
    display();
    break;
  case GLUT_KEY_UP:
    iso += 0.02;
    printf("l %f\n", iso);
    polygonize();
    display();
    break;
  }
}


/**********************ȂƂ悢Ƃ낱܂***********************/

int main(int argc, char** argv){
  printf("㉺L[ : lʂ̏㉺\n\n");
  
  sampleFunction();
  iso = 0;
  
  ver = NULL;
  polygonize();
  
  //]Ȃǂ̏
  qw = 1;
  qx = qy =  qz = 0;
  zoom = 1;
  shiftX = shiftY = 0;
  
  //EBhȄ
  glutInit(&argc, argv); 
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH); //gpobt@̐ݒ
  glutInitWindowSize(800, 800); //EBhȆ傫
  glutCreateWindow("prog5-2"); //EBhẼ^Cg
  
  myinit(); //OpenGL ̏
  glutReshapeFunc(myReshape); //EBhETCYύXꂽɌĂ΂֐ݒ
  glutDisplayFunc(display);  //EBhE̍XV̂߂̊֐ݒ
  glutMouseFunc(mouse); //}EX삳ꂽƂɌĂ΂֐ݒ
  glutSpecialFunc(specialKeys);
  
  glutMainLoop(); //C[v
  
  return 0;
}

